unit Unit9;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics,
  Controls, Forms, Dialogs, RVStyle, RVScroll, RichView, RVEdit, StdCtrls,
  RVSymbolStrFuncs, RVUni;

type
  TMyForm = class(TForm)
    rve: TRichViewEdit;
    RVStyle1: TRVStyle;
    Button1: TButton;
    Button2: TButton;
    Button4: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
  private
    procedure AjouteStyles;
    { Private declarations }
  public
    { Public declarations }
  end;

var
  MyForm: TMyForm;

implementation

{$R *.dfm}

procedure TMyForm.AjouteStyles;
var
  TextStyle: TFontInfo;
  StyleNo: Integer;
begin

  TextStyle := TFontInfo.Create(nil);
  //TextStyle.Assign(rve.Style.TextStyles[rve.CurTextStyleNo]);
  TextStyle.Color := clBlack;
  TextStyle.BackColor := clInfoBk;
  TextStyle.Size := 14;
  TextStyle.FontName := 'Times New Roman';
  TextStyle.StyleName := 'Normal Text';
  rve.Style.TextStyles.Add;
  StyleNo := rve.Style.TextStyles.Count - 1;
  // CouleursStyles[pique] := StyleNo;
  rve.Style.TextStyles[StyleNo].Assign(TextStyle);
  rve.Style.TextStyles[StyleNo].Standard := False;
  TextStyle.Free;

  TextStyle := TFontInfo.Create(nil);
  //TextStyle.Assign(rve.Style.TextStyles[rve.CurTextStyleNo]);
  TextStyle.Color := clNavy;
  TextStyle.BackColor := clInfoBk;
  TextStyle.Size := 15;
  TextStyle.FontName := 'Symbol';
  TextStyle.StyleName := 'Pique';
  rve.Style.TextStyles.Add;
  StyleNo := rve.Style.TextStyles.Count - 1;
  //CouleursStyles[pique] := StyleNo;
  rve.Style.TextStyles[StyleNo].Assign(TextStyle);
  rve.Style.TextStyles[StyleNo].Standard := False;
  TextStyle.Free;

  TextStyle := TFontInfo.Create(nil);
  //TextStyle.Assign(rve.Style.TextStyles[rve.CurTextStyleNo]);
  TextStyle.Color := clRed;
  TextStyle.BackColor := clInfoBk;
  TextStyle.Size := 15;
  TextStyle.FontName := 'Symbol';
  TextStyle.StyleName := 'Coeur';
  rve.Style.TextStyles.Add;
  StyleNo := rve.Style.TextStyles.Count - 1;
  //CouleursStyles[coeur] := StyleNo;
  rve.Style.TextStyles[StyleNo].Assign(TextStyle);
  rve.Style.TextStyles[StyleNo].Standard := False;
  TextStyle.Free;

  TextStyle := TFontInfo.Create(nil);
  //TextStyle.Assign(rve.Style.TextStyles[rve.CurTextStyleNo]);
  TextStyle.Color := $0099FF;
  TextStyle.BackColor := clInfoBk;
  TextStyle.Size := 15;
  TextStyle.FontName := 'Symbol';
  TextStyle.StyleName := 'Carreau';
  rve.Style.TextStyles.Add;
  StyleNo := rve.Style.TextStyles.Count - 1;
  //CouleursStyles[carreau] := StyleNo;
  rve.Style.TextStyles[StyleNo].Assign(TextStyle);
  rve.Style.TextStyles[StyleNo].Standard := False;
  TextStyle.Free;

  TextStyle := TFontInfo.Create(nil);
  //TextStyle.Assign(rve.Style.TextStyles[rve.CurTextStyleNo]);
  TextStyle.Color := clGreen;
  TextStyle.BackColor := clInfoBk;
  TextStyle.Size := 15;
  TextStyle.FontName := 'Symbol';
  TextStyle.StyleName := 'Trefle';
  rve.Style.TextStyles.Add;
  StyleNo := rve.Style.TextStyles.Count - 1;
  //CouleursStyles[trefle] := StyleNo;
  rve.Style.TextStyles[StyleNo].Assign(TextStyle);
  rve.Style.TextStyles[StyleNo].Standard := False;
  TextStyle.Free;


end;

procedure TMyForm.Button1Click(Sender: TObject);
begin
  rve.Style.ResetTextStyles; // these styles will be ignored
  AjouteStyles;              // these styles will be ignored
  rve.RVFTextStylesReadMode := rvf_sInsertMerge; // using styles from file
  rve.LoadRVF('board.rvf');
  rve.Format;
end;

procedure TMyForm.Button2Click(Sender: TObject);
begin
  rve.Style.ResetTextStyles;
  AjouteStyles;
  rve.RVFTextStylesReadMode := rvf_sIgnore; // ignoring styles from file
  rve.LoadRVF('board.rvf');
  rve.Format;
end;

{
 This procedure conver #167 to #170 characters to Unicode, assuming that these
 characters are from Symbol font.
}
procedure TMyForm.Button4Click(Sender: TObject);
var
  Ch: AnsiChar;
  Original, Replacement: UnicodeString;
  i: Integer;
begin
  rve.BeginUpdate;
  for Ch := #167 to #170 do
  begin
    Original := RVU_AnsiToUnicode(1252 {Western code page}, Ch);
    Replacement := RV_MakeKnownSymbolFontStrA(Ch, rvksfSymbol);
    rve.MoveCaret(rvcmTop);
    while rve.SearchTextW(Original, [rvseoDown]) do
    begin
      // rve.ApplyTextStyle(0);
      rve.InsertTextW(Replacement);
    end;
  end;
  rve.EndUpdate;
  //converting all styles from Symbol to Times New Roman
  for i := 0 to rve.Style.TextStyles.Count - 1 do
    if rve.Style.TextStyles[i].FontName = 'Symbol' then
    begin
      rve.Style.TextStyles[i].FontName := 'Times New Roman';
      rve.Style.TextStyles[i].Charset := DEFAULT_CHARSET;
    end;
  rve.Format;
end;

end.
